using System;
using System.Xml;
using System.Collections.Generic;
using System.Text;

namespace XpathDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            XmlDocument docItems = new XmlDocument();
            docItems.Load(@"..\..\..\..\items.xml");

            XmlNodeList allItems = docItems.SelectNodes("/items/item");
            Console.WriteLine("Found {0} items", allItems.Count);

            XmlNode thirdItem = docItems.SelectSingleNode("/items/item[2]");
            Console.WriteLine("Third node is {0}", thirdItem.Attributes["name"].Value);

            // return a list of all attributes where the weight is > 10...
            XmlNodeList heavyAttribs = docItems.SelectNodes(
                "/items/item/attribute[@value > 10 and @name='weight']");
            Console.WriteLine("Heavy items:");
            foreach (XmlNode heavyAttrib in heavyAttribs)
            {
                Console.WriteLine(heavyAttrib.ParentNode.Attributes["name"].Value);
            }

            // return all capacities and weights of all items
            XmlNodeList cw = docItems.SelectNodes(
                "//attribute[@name='capacity'] | //attribute[@name='weight']");
            // do something with the list of capacities and weights...

            Console.WriteLine("Heavy Items (descendant axis predicate):");
            XmlNodeList heavyItems = docItems.SelectNodes(
                "//items/item[descendant::attribute[@name='weight' and @value > 10]]");
            foreach (XmlNode heavyItem in heavyItems)
            {
                Console.WriteLine(heavyItem.Attributes["name"].Value);
            }

            Console.ReadLine();
        }
    }
}
