using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;

namespace AbortThreads
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread.CurrentThread.Name = "MAIN";
            PrintMessage("Application Started.");
            Thread worker = new Thread(new ThreadStart(DoWork));
            worker.Name = "WORKER";
            worker.Start();
            Console.WriteLine("Press Enter to Abort the Thread!");
            Console.ReadLine();
            worker.Abort();
            Console.WriteLine("Thread abort signal sent.");
            Console.ReadLine();
        }

        static void PrintMessage(string msg)
        {
            Console.WriteLine("[{0}] {1}", Thread.CurrentThread.Name, msg);
        }

        static void DoWork()
        {
            try
            {
                while (true)
                {
                    Console.Write("...");
                    Thread.Sleep(100); // small time delay to simulate real work
                }
            }
            catch (Exception e)
            {
                Thread.ResetAbort();
                PrintMessage("Trapped: " + e.ToString());
            }
        }
    }
}
