using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;

namespace RunThreads
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread.CurrentThread.Name = "MAIN";
            Console.WriteLine("[{0}] Hello.", Thread.CurrentThread.Name);
            Thread workerThread = new Thread(new ThreadStart(WorkerMethod));
            workerThread.Name = "WORKER";
            Console.WriteLine("[{0}] Created the new worker thread, {1}",
                Thread.CurrentThread.Name, workerThread.Name);
            workerThread.Start();

            while (workerThread.IsAlive)
            {
                // do nothing until its finished
            }
            Console.WriteLine("Looks like the worker thread finished its job.");

            Console.ReadLine();
        }

        static void WorkerMethod()
        {
            for (int i = 0; i < 20; i++)
            {
                Console.WriteLine("[{0}] Doing some work.", Thread.CurrentThread.Name);
            }
        }
    }
}
