using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;

namespace ThreadEvents
{
    class Program
    {
        static ManualResetEvent mre = new ManualResetEvent(false);
        static string sharedResource = "Shared.";

        static void Main(string[] args)
        {
            Thread[] workers = new Thread[10];
            Console.WriteLine("Queueing up threads...");
            for (int i = 0; i < 10; i++)
            {
                Thread worker = new Thread(new ThreadStart(DoWork));
                workers[i] = worker;
                worker.Start();
            }
            // give all the other workers time to line up
            // behind the reset event
            Thread.Sleep(TimeSpan.FromSeconds(2));
            Console.WriteLine("Threads should be lined up, about to signal them to go.");
            mre.Set();
            foreach (Thread worker in workers)
                worker.Join();
            Console.WriteLine("Work's all done, work result: {0}", sharedResource);
            Console.ReadLine();
        }

        static void DoWork()
        {
            mre.WaitOne();
            lock (sharedResource)
            {
                Console.WriteLine("Work was able to be performed.");
                sharedResource += " modified.";
            }
            
        }
    }
}
