using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;

namespace CodeAttributeDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            Type t = typeof(Shape);
            DataTableAttribute[] attribs = (DataTableAttribute[])t.GetCustomAttributes(typeof(DataTableAttribute), true);
            DataTableAttribute attrib = attribs[0];

            Console.WriteLine("The Shape class is persisted via the {0} table in a database.", attrib.TableName);

            DataColumnAttribute[] cols = (DataColumnAttribute[])
                t.GetProperty("Name").GetCustomAttributes(typeof(DataColumnAttribute), true);
            Console.WriteLine("The 'Name' property, when persisted to a database, is called {0}, and is of type {1}",
                cols[0].ColumnName, cols[0].DataType.ToString());

            Console.ReadLine();
        }
    }
}
