using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;

namespace EventInfoDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            ReflectMethods.Customer<string> cust = new ReflectMethods.Customer<string>();
            ReflectMethods.PropertyChangedDelegate propDel = new ReflectMethods.PropertyChangedDelegate(cust_OnPropertyChanged);
            cust.OnPropertyChanged += propDel;

            EventInfo evt = cust.GetType().GetEvent("OnPropertyChanged");
            Console.WriteLine("Event {0}:", evt.Name);
            Console.WriteLine("\tMulticast?: {0}", evt.IsMulticast);
            Console.WriteLine("\tModule: {0}", evt.Module.Name);

            MethodInfo addMethod = evt.GetAddMethod();
            Console.WriteLine("\tAdd Method: {0}", addMethod.ToString());
            Console.WriteLine("\tRemove Method: {0}", evt.GetRemoveMethod().ToString());

            cust.PubData = 99;

            evt.RemoveEventHandler(cust, propDel);
            cust.PubData = 42;

            evt.AddEventHandler(cust, propDel);
            evt.AddEventHandler(cust, propDel);
            cust.PubData = 150;

            Console.ReadLine();
            
        }

        static void cust_OnPropertyChanged(string propName, int value)
        {
            Console.WriteLine("Customer Property changed : {0}, {1}", propName, value);
        }
    }
}
