using System;
using System.Reflection;
using System.Collections.Generic;
using System.Text;

namespace ReflectMethods
{
    class Program
    {
        static void Main(string[] args)
        {
            Customer<string> cust = new Customer<string>();
            Type t = cust.GetType();

            MethodInfo method = t.GetMethod("DoSomething");
            Console.WriteLine(method.Name);
            Console.WriteLine("--------------------------");
            Console.WriteLine("Abstract: {0}, Visible to Assembly: {1}, Constructor: {2}, Sealed: {3}",
                method.IsAbstract, method.IsAssembly, method.IsConstructor, method.IsFinal);
            Console.WriteLine("Generic: {0}, Virtual: {1}, Static: {2}",
                method.IsGenericMethod, method.IsVirtual, method.IsStatic);
            Console.WriteLine("{0} returns {1}",
                method.Name, method.ReturnType.ToString());
            Console.WriteLine("Parameters:");
            foreach (ParameterInfo p in method.GetParameters())
            {
                Console.WriteLine("\t{0} : {1} [{2}]{3}",
                    p.Name, p.ParameterType.ToString(),
                    p.IsOut ? "Out" : "In",
                    p.ParameterType.IsGenericParameter ? "* Generic" : "");
            }
            Console.WriteLine("Local variables within method:");
            foreach (LocalVariableInfo lvi in method.GetMethodBody().LocalVariables)
            {
                Console.WriteLine(lvi.ToString());
            }

            Console.ReadLine();
        }
    }
}
