using System;
using System.Security;
using System.Security.Cryptography;
using System.Collections.Generic;
using System.Text;

namespace DPAPIDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            string messageToProtect = "aaaabbbbccccdddd";
            byte[] messageArray = System.Text.ASCIIEncoding.ASCII.GetBytes(messageToProtect);

            ProtectedMemory.Protect(messageArray, MemoryProtectionScope.SameLogon);
            
            // this should print out 16 bytes of garbage
            Console.WriteLine(System.Text.ASCIIEncoding.ASCII.GetString(messageArray));

            ProtectedMemory.Unprotect(messageArray, MemoryProtectionScope.SameLogon);

            // now it should print just fine
            Console.WriteLine(System.Text.ASCIIEncoding.ASCII.GetString(messageArray));

            // protect data that will be used in a stream, in a file, etc
            string fileMessage = "The purple turtle flies coach at dawn...";
            byte[] fileMsgArray = System.Text.ASCIIEncoding.ASCII.GetBytes(fileMessage);

            // some array of bytes for introduced entropy
            byte[] entropy = { 0, 1, 3, 5, 7, 9 };
            byte[] protectedMessage = ProtectedData.Protect(
                fileMsgArray, entropy, DataProtectionScope.CurrentUser);

            Console.WriteLine("Protected byte array:");
            Console.WriteLine(System.Text.ASCIIEncoding.ASCII.GetString(protectedMessage));

            byte[] clearMessage = ProtectedData.Unprotect(
                protectedMessage, entropy, DataProtectionScope.CurrentUser);
            Console.WriteLine("Unprotected/Decrypted Data:");
            Console.WriteLine(ASCIIEncoding.ASCII.GetString(clearMessage));


            Console.ReadLine();
        }
    }
}
