using System;
using System.Text;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Service : System.Web.Services.WebService
{
    public Service () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public string HelloWorld() {
        return "Hello World";
    }

    [WebMethod(Description = "Concatenates two strings, returning the result and length.")]
    public int StringConcat(string string1, string string2, 
        out string stringTotal)
    {
        StringBuilder sb = new StringBuilder();
        sb.Append(string1);
        sb.Append(string2);
        stringTotal = sb.ToString();
        return stringTotal.Length;
    }

    [WebMethod(Description="Transfers money between accounts.",
        TransactionOption=System.EnterpriseServices.TransactionOption.Required)]
    public void Transfer(string sourceAccount, string destAccount,
        decimal amount)
    {
        // transfer 'amount' from 'sourceAccount' to 'destAccount'
    }

    [WebMethod(Description="Inquires about a specific bank account's balance.")]
    public decimal Inquiry(string account)
    {
        return 0.0m;
    }

    [WebMethod(Description="Deposits money into an account.",
        TransactionOption=System.EnterpriseServices.TransactionOption.Required)]
    public void Deposit(string destAccount, decimal amount)
    {
        // deposit 'amount' into 'destAccount'
    }

    [WebMethod(Description="Sets a session state variable",
        EnableSession=true)]
    public void SetSessionVariable(string variable, string value)
    {
        Session[variable] = value;
    }

    [WebMethod(Description="Queries a session state variable",
        EnableSession=true)]
    public string QuerySessionVariable(string variable)
    {
        return (string)Session[variable];
    }

    [WebMethod(Description="Sets an application-wide variable")]
    public void SetAppVariable(string variable, string value)
    {
        Application[variable] = value;
    }

    [WebMethod(Description="Obtains an application-wide variable")]
    public string GetAppVariable(string variable)
    {
        return (string)Application[variable];
    }
    
}
