using System;
using System.Net;
using System.Net.NetworkInformation;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Agile1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            System.Net.NetworkInformation.NetworkChange.NetworkAddressChanged += 
                new NetworkAddressChangedEventHandler(NetworkChange_NetworkAddressChanged);
            System.Net.NetworkInformation.NetworkChange.NetworkAvailabilityChanged += 
                new NetworkAvailabilityChangedEventHandler(NetworkChange_NetworkAvailabilityChanged);
        }

        delegate void RespondDelegate();

        void NetworkChange_NetworkAvailabilityChanged(object sender, 
            System.Net.NetworkInformation.NetworkAvailabilityEventArgs e)
        {
            RespondDelegate d =
                delegate()
                {
                    lbLog.Items.Add(
                        string.Format("Network availability changed. Net {0} available.",
                        e.IsAvailable ? "is" : "is not"));
                };         
            this.Invoke(d);   
        }

        void NetworkChange_NetworkAddressChanged(object sender, EventArgs e)
        {                        
            RespondDelegate d =
                delegate()
                {
                    bool hasOneGateway = false;
                    NetworkInterface[] nis = NetworkInterface.GetAllNetworkInterfaces();
                    foreach (NetworkInterface ni in nis)
                    {
                        IPInterfaceProperties ipProps = ni.GetIPProperties();
                        if (ipProps.GatewayAddresses.Count > 0)
                            hasOneGateway = true;
                    }
                    if (hasOneGateway)
                        lbLog.Items.Add("Network address changed (probably still online)");
                    else
                        lbLog.Items.Add("Network address changed (probably NOT online)");
                };
            this.Invoke(d);            
        }
    }
}