using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Ipc;
using System.Collections.Generic;
using System.Text;

using SharedLibrary;

namespace RemotingClient
{
    class Program
    {
        static void Main(string[] args)
        {
            IpcChannel ipc = new IpcChannel("sampleapp_client");
            ChannelServices.RegisterChannel(ipc, false);

            ISharedObject sharedObj = (ISharedObject)
             Activator.GetObject(typeof(ISharedObject), "ipc://sampleapp/HostedObject.rem");

            if (sharedObj == null)
            {
                Console.WriteLine("Failed to establish IPC link");
                return;
            }

            sharedObj.PrintMessage("Hello from AppDomain " + AppDomain.CurrentDomain.FriendlyName);

            Console.ReadLine();

        }
    }
}
