using System;
using System.Collections.Generic;
using System.Text;

using SharedLibrary;

namespace TcpClient
{
    class Program
    {
        static void Main(string[] args)
        {
            ISharedObject sharedObj = (ISharedObject)
                Activator.GetObject(typeof(ISharedObject),
                "tcp://localhost:8080/SharedObject.rem");
            if (sharedObj == null)
            {
                Console.WriteLine("Failed to obtain remote reference.");
            }
            else
            {
                Customer cust = new Customer();
                cust.ID = "newcust001";
                cust.FirstName = "John";
                cust.LastName = "Customer";
                sharedObj.ProcessCustomer(cust);
                Customer retrievedCust = sharedObj.GetCustomer("newcust002");
                Console.WriteLine("Retrieved customer from remote location:  " +
                    retrievedCust.FirstName + " " + retrievedCust.LastName);
            }
            Console.ReadLine();
           
        }
    }
}
